var Clock = new Class({
  Implements: Options,
  initialize: function(element, options){
    this.setOptions(options);
    this.element = $(element);
    this.elements();
    
    this.update.periodical(1000, this);
  },
  elements: function(){
    new Element('div.hour', {html: '<span class="digit small"></span><span class="digit"></span>'}).inject(this.element);
    new Element('div.bullet').inject(this.element);
    new Element('div.minute', {html: '<span class="digit"></span><span class="digit small"></span>'}).inject(this.element);
    
  },
  update: function(){
    if(this.element.getElement('.bullet').getStyle('background') == 'transparent'){
      this.element.getElement('.bullet').setStyle('background', 'url(Images/Digit_double_point.png) 50% 50% no-repeat')
    } else {
      this.element.getElement('.bullet').setStyle('background', 'transparent');
    };
    
    var h = this.calculateBackground(this.tztime().getHours(), 'h');

    this.element.getElements('div.hour .digit').each(function(e, idx){
       e.setStyle('background-position', '0 '+ h[idx]+'px');
    });
    var min = this.calculateBackground(this.tztime().getMinutes(), 'm');

    this.element.getElements('div.minute .digit').each(function(e, idx){
       e.setStyle('background-position', '0 '+ min[idx]+'px');
    });
    
    if(this.element.id == 'local'){
      $('daylit').setStyle('background-position', '0 ' + ((this.tztime().getDay()-1)*12)*-1 + 'px' )
      var day = this.calculateBackground(this.tztime().getDate(), 'd')
      $('day').getElements('.digit').each(function(e, idx){
        e.setStyle('background-position', '0 '+ day[idx]+'px');
      });
    }
    
  },
  calculateBackground: function(number, part){
    var number = number.toString();
    var res = [];
    if(number.charAt(1) == ''){
      number = "0"+number;
    };
    if(part == 'h'){
      res.push((number.charAt(0)*17)*-1);
      res.push((number.charAt(1)*24)*-1);
    }
    if(part == 'm'){
      res.push((number.charAt(0)*24)*-1);
      res.push((number.charAt(1)*17)*-1);
    }
    
    if(part == 'd'){
      res.push((number.charAt(0)*12)*-1);
      res.push((number.charAt(1)*12)*-1);
    }
    return res;
  },
  tztime: function(){
    if(typeof(this.options.tz) != 'undefined') {
      var d = new Date(),
          localTime = d.getTime(),
          localOffset = d.getTimezoneOffset() * 60000,
          utc = localTime + localOffset;
      return new Date(utc + (3600000*this.options.tz));
    } else {
     return new Date();
    };
  }
});