var Countdown = new Class({
    Implements: Options,
    initialize: function(options){
      this.setOptions(options||{});
      
      this.finish = new Date(Date.UTC(2011, 1, 14, 1));
      this.elements();
    },
    elements: function(){
      var wrapper = new Element('div');
      var digit = new Element('span.digit');
      
      var seconds = new Element('div#sec');
      var minutes = new Element('div#min');
      var hours = new Element('div#hours');
      var days = new Element('div#days');
      
      seconds.inject(wrapper);
      minutes.inject(wrapper);
      hours.inject(wrapper);
      days.inject(wrapper);
      
      wrapper.getElements('div').each(function(e){
        var digw = new Element('div.number');
        digit.clone().inject(digw);
        digit.clone().inject(digw);
        digw.inject(e);
      });
      
      wrapper.inject($('countdown'));
      
     
      this.update.periodical(1000, this);
    },
    update: function(){
       if(new Date() >= new Date(Date.UTC(2011, 1, 14, 1)) 
          && Konfabulator.preferences.display.hidden == false
          && Konfabulator.preferences.display.value == 'countdown'){
          Konfabulator.preferences.display.hidden = true;
          Konfabulator.preferences.display_after.hidden = false;
          return;
        }
      
      var parts = this.calculate(new Date(), new Date(Date.UTC(2011, 1, 14, 1)));

      var bgSec = this.calculateBackground(parts.second);
      $('countdown').getElements('div#sec .digit').each(function(e, idx){
        e.setStyle('background-position', '0 '+ bgSec[idx]+'px');
      });
      
      var bgMin = this.calculateBackground(parts.minutes) 
      $('countdown').getElements('div#min .digit').each(function(e, idx){
        e.setStyle('background-position', '0 '+ bgMin[idx]+'px');
      });
      
      var bgH = this.calculateBackground(parts.hours) 
      $('countdown').getElements('div#hours .digit').each(function(e, idx){
        e.setStyle('background-position', '0 '+ bgH[idx]+'px');
      });

      var bgDays = this.calculateBackground(parts.days) 
      $('countdown').getElements('div#days .digit').each(function(e, idx){
        e.setStyle('background-position', '0 '+ bgDays[idx]+'px');
      });

    },
    calculate: function (start, from) {

			var millis = Math.max(0, from - start),
				time = Math.floor(millis / 1000),
				countdown = {
					days: Math.floor(time / (60 * 60 * 24)), 
					time: time,
					millis: millis
				};
			
      time %= (60 * 60 * 24);
      countdown.hours = Math.floor(time / (60 * 60));
			time %= (60 * 60);
	    countdown.minutes = Math.floor(time / 60);
	    countdown.second = time % 60;

			return countdown

		},
    calculateBackground: function(number){
       var number = number.toString();
        var res = [];
        if(number.charAt(1) == ''){
          number = "0"+number;
        };
        res.push((number.charAt(0)*10)*-1);
        res.push((number.charAt(1)*10)*-1);
        return res;
    }
});